#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Wed Jan  2 10:25:46 2019

@author: adityamenon
"""

from __future__ import division
from sklearn.gaussian_process import GaussianProcessRegressor
from sklearn.gaussian_process.kernels import DotProduct, RBF, WhiteKernel, Matern,RationalQuadratic,ExpSineSquared, ConstantKernel 
from sklearn.model_selection import train_test_split
import matplotlib.pyplot as plt
import pandas as pd


dataset = pd.read_excel('PU training dataset.xlsx', sheet_name='Middle Bottom layer')

yn=1
y = dataset.iloc[:, yn-1]
x = dataset.iloc[:, 3:]

trainscore=0
testscore=0       
#Finding the best model (hypothesis)
while trainscore<0.7 or testscore<0.7:
    xtrain, xtest, ytrain, ytest = train_test_split(x,y, test_size=0.3, train_size=0.7)
    kernel = ConstantKernel(1, (0.01, 10.0)) + DotProduct() + WhiteKernel() + ExpSineSquared()+RationalQuadratic()
    
    gpr = GaussianProcessRegressor(kernel=kernel,\
                                   random_state=0).fit(xtrain, ytrain)
    
 
    
    print("Test score for GP has not converged yet")
    trainscore=gpr.score(xtrain, ytrain)    
    testscore=gpr.score(xtest, ytest)
    
ypred=gpr.predict(x)
