#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Mon Jan 14 12:33:10 2019

@author: adityamenon
"""
from __future__ import division
import pandas as pd
import matplotlib.pyplot as plt
from sklearn.model_selection import train_test_split
from sklearn.ensemble import RandomForestRegressor

# set working directory and load data (From an Excel file where 'y' data is in column 1 and x data follows.
# First Row of Excel should be the features names.)
dataset = pd.read_excel('PU training dataset.xlsx', sheet_name='Top-Middle layer')
zn=3
z = dataset.iloc[:, zn-1]
y = dataset.iloc[:, 3:]


trainscore=0
testscore=0        
#Finding the best model (hypothesis)
while trainscore<0.86 or testscore<0.86:
    ytrain, ytest, ztrain, ztest = train_test_split(y,z, test_size=0.2, train_size=0.8)
    regr = RandomForestRegressor(max_depth=None, random_state=0,
                                 n_estimators=100)
    regr.fit(ytrain, ztrain)
    RandomForestRegressor(bootstrap=True, criterion='mse', max_depth=None,
               max_features='auto', max_leaf_nodes=None,
               min_impurity_decrease=0.0, min_impurity_split=None,
               min_samples_leaf=1, min_samples_split=2,
               min_weight_fraction_leaf=0.0, n_estimators=100, n_jobs=4,
               oob_score=False, random_state=0, verbose=0, warm_start=False)
    
    print("Test score for random forest has not converged yet")
    
    testscore=regr.score(ytest, ztest)
    trainscore=regr.score(ytrain, ztrain)

feat_imp=regr.feature_importances_
print(ytrain.index)


pred=pd.Series(regr.predict(ytest),index=ztest.index)
plt.figure()
'''testscatter=plt.scatter(ztest.index,ztest)
trainscatter=plt.scatter(pred.index,pred)
plt.ylabel(ztrain.name)
plt.xlabel('Sample Index')
plt.legend([testscatter, trainscatter],['Test','Predicted'])'''
testscatter=plt.scatter(ztest,pred,linewidth=2.0)
plt.ylabel('Predicted ' + ztrain.name)
plt.xlabel('Actual ' + ztrain.name)
plt.plot([0, max(ztest)], [0, max(ztest)], color = 'black', linewidth = 0.5,linestyle='-.')

plt.savefig(ztrain.name + ' - Pred vs Test.png', dpi=600, bbox_inches="tight")

plt.close()

(pd.Series(regr.feature_importances_, index=ytrain.columns)
   .nlargest(14)
   .plot(kind='barh')) 
plt.xlabel('Feature importance - ' + ztrain.name)
plt.savefig(ztrain.name + ' - Feature importance.png', dpi=600,bbox_inches="tight")

estimator=regr.estimators_[99]

from sklearn.tree import export_graphviz
# Export as dot file
export_graphviz(estimator, out_file=ztrain.name + ' - tree.dot', 
                feature_names = ytrain.columns,
                rounded = True, proportion = False, 
                precision = 2, filled = True, impurity = True)

# Convert to png using system command (requires Graphviz)
from subprocess import call
call(['dot', '-Tpng', ztrain.name + ' - tree.dot', '-o', ztrain.name + ' - tree.png', '-Gdpi=600'])
