#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Mon Jan 14 12:33:10 2019

@author: adityamenon
"""
from __future__ import division
import pandas as pd
import matplotlib.pyplot as plt
from sklearn.model_selection import train_test_split
from sklearn.ensemble import RandomForestRegressor
from sklearn import preprocessing

# set working directory and load data (From an Excel file where 'z' data is in column 1 and x data follows.
# First Rows of Excel should be the features names.)
dataset = pd.read_excel('PU training dataset.xlsx', sheet_name='Non-HML')
zn=2
z = dataset.iloc[:, zn-1]
y = dataset.iloc[:, 3:]

enc = preprocessing.OneHotEncoder()
enc.fit(y)
onehotlabels = enc.transform(y).toarray()
onehotlabels.shape

trainscore=0
testscore=0   
     
#Finding the best model (hypothesis)
while trainscore<0.7 or testscore<0:
    ytrain, ytest, ztrain, ztest = train_test_split(onehotlabels,z, test_size=0.2, train_size=0.8)
    regr = RandomForestRegressor(max_depth=None, random_state=0,
                                 n_estimators=100)
    regr.fit(ytrain, ztrain)
    RandomForestRegressor(bootstrap=True, criterion='mse', max_depth=None,
               max_features='auto', max_leaf_nodes=None,
               min_impurity_decrease=0.0, min_impurity_split=None,
               min_samples_leaf=1, min_samples_split=2,
               min_weight_fraction_leaf=0.0, n_estimators=100, n_jobs=4,
               oob_score=False, random_state=0, verbose=0, warm_start=False)
    
    print("Test score for random forest has not converged yet")
    
    testscore=regr.score(ytest, ztest)
    trainscore=regr.score(ytrain, ztrain)


pred=pd.Series(regr.predict(ytest),index=ztest.index)
plt.figure()
testscatter=plt.scatter(ztest,pred,linewidth=2.0)
plt.ylabel('Predicted ' + ztrain.name)
plt.xlabel('Actual ' + ztrain.name)
plt.plot([0, max(z)], [0, max(z)], color = 'black', linewidth = 0.5,linestyle='-.')

plt.savefig(ztrain.name + ' - Pred vs Test.png', dpi=600, bbox_inches="tight")
